#include <stdio.h>
#include <stdlib.h>
#include <dispatch/dispatch.h>

#include "matrix.h"

int main(int argc, char *argv[]){
	int line;
	dispatch_queue_t globalQueue;
			
	initialize(argc, argv);

	globalQueue = dispatch_get_global_queue (DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
	
	for (line = 0; line < dimension; line++) {
		dispatch_apply(dimension, globalQueue, ^(size_t column) {
			matrixProduct[line][column] = scalar_product(matrixA[line], matrixB[column]);
		});
	}

	return 0;
}