#include <stdio.h>
#include <stdlib.h>
#include <dispatch/dispatch.h>

#include "matrix.h"

int main(int argc, char *argv[]){
	dispatch_queue_t globalQueue;
			
	initialize(argc, argv);

	globalQueue = dispatch_get_global_queue (DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
	
	
	dispatch_apply(dimension, globalQueue, ^(size_t line) {
		int column;
		for (column = 0; column < dimension; column ++) {
			matrixProduct[line][column] = scalar_product(matrixA[line], matrixB[column]);
		}
	});

	return 0;
}